﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.VslRedmond.Api;

namespace Benday.VslRedmond.UnitTests
{
    [TestClass]
    public class CalculatorFixture
    {
        [TestInitialize]
        public void OnTestInitialize()
        {
            _SystemUnderTest = null;
        }

        private Calculator _SystemUnderTest;
        public Calculator SystemUnderTest
        {
            get
            {
                if (_SystemUnderTest == null)
                {
                    _SystemUnderTest = new Calculator();
                }

                return _SystemUnderTest;
            }
        }

        public CalculatorFixture()
        {
        }

        [TestMethod]
        public void Add()
        {
            // arrange
            int expected = 5;
            int value1 = 3;
            int value2 = 2;

            // act
            int actual = 
                SystemUnderTest.Add(value1, value2);

            // assert
            Assert.AreEqual<int>(expected, actual, 
                "Got the wrong value back.");
        }

        [TestMethod]
        public void Subtract()
        {
            // arrange
            int expected = 1;
            int value1 = 3;
            int value2 = 2;

            // act
            int actual =
                SystemUnderTest.Subtract(value1, value2);

            // assert
            Assert.AreEqual<int>(expected, actual,
                "Got the wrong value back.");
        }

        [TestMethod]
        public void Multiply()
        {
            // arrange
            int expected = 6;
            int value1 = 3;
            int value2 = 2;

            // act
            int actual =
                SystemUnderTest.Multiply(value1, value2);

            // assert
            Assert.AreEqual<int>(expected, actual,
                "Got the wrong value back.");
        }

        [TestMethod]
        public void Divide()
        {
            // arrange
            int expected = 2;
            int value1 = 6;
            int value2 = 3;

            // act
            int actual =
                SystemUnderTest.Divide(value1, value2);

            // assert
            Assert.AreEqual<int>(expected, actual,
                "Got the wrong value back.");
        }

        //[TestMethod]
        //public void ConstructThingyViewModelDoesntBlowUp()
        //{
        //    var thingy = new Thingy();

        //    Assert.AreNotEqual<int>(0, thingy.AddressType.Count, "errorMessage");
        //}

        [TestMethod]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void DivideByZeroShouldThrowArgumentOutOfRangeException()
        {
            // arrange
            int value1 = 6;
            int value2 = 0;

            // act

            int actual =
                SystemUnderTest.Divide(value1, value2);
        }
    }
}
